# BEGIN SourceDeps(oneline):
BuildRequires: gcc-c++ kdelibs libICE-devel libSM-devel zlib-devel libtqt-devel
# END SourceDeps(oneline)
%define oldname gambas
Name:		gambas1
Summary: 	IDE based on a basic interpreter with object extensions
Version: 	1.0.19
Release: 	alt1_17
License: 	GPL+
Group: 		Development/Tools
URL: 		http://gambas.sourceforge.net/
Source0: 	http://download.sourceforge.net/%{oldname}/%{oldname}-%{version}.tar.bz2
BuildRequires:	kdelibs-devel automake autoconf libSDL-devel libSDL_mixer-devel
BuildRequires:	libmysqlclient-devel postgresql-devel libsqlite3-devel libX11-devel
BuildRequires:	desktop-file-utils gettext-devel curl-devel libXext-devel
BuildRequires:	qt4-devel bzip2-devel libxslt-devel libxml2-devel
BuildRequires:	libltdl7-devel
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
# Code is not 64 bit clean.
# http://sourceforge.net/mailarchive/message.php?msg_id=15024630
ExcludeArch:	x86_64 ppc64 s390x
# Code is now endian clean.
# ExcludeArch:	ppc
Patch0:		gambas-1.0.9-gcc4.patch
Patch1:		gambas-1.0.6-dont-make-links.patch
Patch2:		gambas-1.0.6-noopt.patch
Patch3:		gambas-1.0.11-desktopfix.patch
Patch4:		gambas-1.0.13-gettextfix.patch
Patch5:		gambas-1.0.16-64bit.patch
Patch6:		gambas-1.0.19-use-system-ltdl.patch
Source44: import.info

%description
Gambas is a free development environment based on a Basic interpreter
with object extensions, like Visual Basic (but it is NOT a clone !).
With Gambas, you can quickly design your program GUI, access MySQL or
PostgreSQL databases, pilot KDE applications with DCOP, translate your
program into many languages, create network applications easily, and so
on...

%package runtime
Summary:        Runtime environment for gambas
Group:          Development/Tools
Provides:	%{oldname} = %{version}-%{release}
Obsoletes:	%{oldname}

%description runtime
Gambas is a free development environment based on a Basic interpreter
with object extensions, like Visual Basic. This package contains the 
runtime components necessary to run programs designed in gambas. 

%package ide
Summary:	Development environment for gambas
Group:		Development/Tools
Requires:	%{name}-runtime = %{version}-%{release}
Requires:	%{name}-gb-compress = %{version}-%{release}
Requires:	%{name}-gb-db = %{version}-%{release}
Requires:	%{name}-gb-debug = %{version}-%{release}
Requires:	%{name}-gb-eval = %{version}-%{release}
Requires:	%{name}-gb-net-curl = %{version}-%{release}
Requires:       %{name}-gb-net = %{version}-%{release}
Requires:       %{name}-gb-qt = %{version}-%{release}
Requires:       %{name}-gb-qt-editor = %{version}-%{release}
Requires:       %{name}-gb-qt-ext = %{version}-%{release}
Requires:       %{name}-gb-qt-kde = %{version}-%{release}
Requires:       %{name}-gb-qt-kde-html = %{version}-%{release}
Requires:       %{name}-gb-sdl = %{version}-%{release}
Requires:       %{name}-gb-vb = %{version}-%{release}
Requires:       %{name}-gb-xml-libxml = %{version}-%{release}
Requires:       %{name}-gb-xml-libxml-rpc = %{version}-%{release}
Requires:       %{name}-gb-xml-libxml-xslt = %{version}-%{release}
Provides:	%{oldname}-devel = %{version}-%{release}
Obsoletes:	%{oldname}-devel, %{oldname}-help, %{oldname}-examples
Provides:	%{oldname}-help = %{version}-%{release}
Provides:	%{oldname}-examples = %{version}-%{release}

%description ide
The gambas-ide package contains the complete Gambas Development 
Environment, with the database manager, the help files, and all 
components. This is what you want to install if you want to 
create new programs with Gambas.

%package gb-compress
Summary:        Gambas component package for compress
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-compress
%%{summary}

%package gb-db
Summary:        Gambas component package for db
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-db
%%{summary}

%package gb-debug
Summary:        Gambas component package for debug
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-debug
%%{summary}

%package gb-eval
Summary:        Gambas component package for eval
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-eval
%%{summary}

%package gb-net
Summary:        Gambas component package for net
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-net
%%{summary}

%package gb-net-curl
Summary:        Gambas component package for net.curl
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-net-curl
%%{summary}

%package gb-qt
Summary:        Gambas component package for qt
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt
%%{summary}

%package gb-qt-editor
Summary:        Gambas component package for qt.editor
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-editor
%%{summary}

%package gb-qt-ext
Summary:        Gambas component package for qt.ext
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-ext
%%{summary}

%package gb-qt-kde
Summary:        Gambas component package for qt.kde
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-kde
%%{summary}

%package gb-qt-kde-html
Summary:        Gambas component package for qt.kde.html
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-kde-html
%%{summary}

%package gb-sdl
Summary:        Gambas component package for sdl
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-sdl
%%{summary}

%package gb-vb
Summary:        Gambas component package for vb
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-vb
%%{summary}

%package gb-xml-libxml
Summary:        Gambas component package for xml.libxml
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-xml-libxml
%%{summary}

%package gb-xml-libxml-rpc
Summary:        Gambas component package for xml.libxml.rpc
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-xml-libxml-rpc
%%{summary}

%package gb-xml-libxml-xslt
Summary:	Gambas component package for xml.libxml.xslt
Group:		Development/Tools
Requires:	%{name}-runtime = %{version}-%{release}

%description gb-xml-libxml-xslt
%%{summary}


%prep
%setup -n %{oldname}-%{version} -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1 -b .ltdl

# We're using the system copy.
rm -rf libltdl/

%build
# Gambas can't deal with -Wp,-D_FORTIFY_SOURCE=2
CFLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=2//g'`
CPPFLAGS="$CPPFLAGS -I/usr/include/tqtinterface"

rm -f  $(find . -type f | egrep "Makefile$") $(find . -type f | egrep "Makefile.in$")
./reconf || echo reconf gives a warning but lets continue anyway
%configure \
	--with-kde-includes=%_includedir/kde \
	--with-kde-libraries=%_libdir/kde \
	--datadir="%{_datadir}" \
	--enable-intl \
	--enable-conv \
	--enable-qt \
	--enable-kde \
	--enable-net \
	--enable-curl \
	--enable-postgresql \
	--enable-mysql \
	--enable-sqlite \
	--enable-sdl \
	--enable-vb
%{__make} %{?_smp_mflags} CPPFLAGS="$CPPFLAGS -I/usr/include/tqtinterface"

%install
export PATH=$RPM_BUILD_ROOT/usr/bin:$PATH
make DESTDIR=$RPM_BUILD_ROOT install
# Yes, I know. Normally we'd nuke the .la files, but Gambas is retar^Wspecial.
# rm -rf $RPM_BUILD_ROOT%{_libdir}/gambas/*.la
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
mkdir -p $RPM_BUILD_ROOT%{_includedir}
install -m0644 ./app/gambas/.icon/32.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/gambas.png
install src/share/gambas.h $RPM_BUILD_ROOT%{_includedir}

desktop-file-install --vendor fedora			\
  --dir ${RPM_BUILD_ROOT}%{_datadir}/applications	\
  debian/gambas.desktop

# Pull buildroot out of the examples files
for i in `grep -lr "$RPM_BUILD_ROOT" $RPM_BUILD_ROOT%{_datadir}/%{oldname}/examples/`; 
do
  sed -i "s|$RPM_BUILD_ROOT||g" $i; 
done

%files runtime
%doc AUTHORS COPYING INSTALL README README.REDHAT TODO
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.component
%{_bindir}/gambas
%{_bindir}/gbi
%{_bindir}/gbx
%{_datadir}/pixmaps/gambas.png
%{_datadir}/applications/*.desktop
%dir %{_datadir}/gambas/
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.info
%{_datadir}/gambas/info/gb.list

%files ide
%{_bindir}/gbc
%{_bindir}/gba
%{_bindir}/gambas-database-manager
%{_includedir}/gambas.h
%{_datadir}/gambas/
%exclude %{_datadir}/gambas/info/

# For what its worth, I think this packaging layout is horrific.
# But, I'm going to play nice with upstream and let the user suffer.
# ~spot

%files gb-compress
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.compress.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.compress.*

%files gb-db
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.db.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.db.*

%files gb-debug
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.debug.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.debug.*

%files gb-eval
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.eval.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.eval.*

%files gb-net
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.net.component
%{_libdir}/gambas/lib.gb.net.so*
%{_libdir}/gambas/lib.gb.net.la
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.net.info
%{_datadir}/gambas/info/gb.net.list

%files gb-net-curl
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.net.curl.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.net.curl.*

%files gb-qt 
%dir %{_libdir}/gambas 
%{_libdir}/gambas/lib.gb.qt.component 
%{_libdir}/gambas/lib.gb.qt.so* 
%{_libdir}/gambas/lib.gb.qt.la 
%dir %{_datadir}/gambas/info 
%{_datadir}/gambas/info/gb.qt.info 
%{_datadir}/gambas/info/gb.qt.list

%files gb-qt-editor 
%dir %{_libdir}/gambas 
%{_libdir}/gambas/lib.gb.qt.editor.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.editor.*

%files gb-qt-ext
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.qt.ext.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.ext.*

%files gb-qt-kde
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.qt.kde.component
%{_libdir}/gambas/lib.gb.qt.kde.so*
%{_libdir}/gambas/lib.gb.qt.kde.la
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.kde.info
%{_datadir}/gambas/info/gb.qt.kde.list

%files gb-qt-kde-html
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.qt.kde.html.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.kde.html.*

%files gb-sdl
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.sdl.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.sdl.*

%files gb-vb
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.vb.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.vb.*

%files gb-xml-libxml
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.xml.libxml.component
%{_libdir}/gambas/lib.gb.xml.libxml.so*
%{_libdir}/gambas/lib.gb.xml.libxml.la
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.xml.libxml.info
%{_datadir}/gambas/info/gb.xml.libxml.list

%files gb-xml-libxml-rpc
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.xml.libxml.rpc.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.xml.libxml.rpc.*

%files gb-xml-libxml-xslt
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.xml.libxml.xslt.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.xml.libxml.xslt.*

%changelog
* Tue Jan 15 2013 Igor Vlasenko <viy@altlinux.ru> 1.0.19-alt1_17
- initial fc import

